> ## Documentation Index
> Fetch the complete documentation index at: https://docs.codeqr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a link

> Retrieve the info for a link.

You can retrieve a link by providing one of the following as a query parameter:

* `domain` and `key`.
* `linkId`.
* `externalId`.


## OpenAPI

````yaml get /links/info
openapi: 3.0.3
info:
  title: CodeQR.io API
  description: >-
    SaaS platform for creating dynamic QR Codes, trackable short links, and
    interactive pages, focused on automation, analytics, and engagement.
  version: 0.0.1
  contact:
    name: CodeQR.io Support
    email: contact@codeqr.io
    url: https://codeqr.io/api
  license:
    name: AGPL-3.0 license
servers:
  - url: https://api.codeqr.io
    description: Production API
security: []
paths:
  /links/info:
    get:
      tags:
        - Links
      summary: Retrieve a link
      description: Retrieve the info for a link.
      operationId: getLinkInfo
      parameters:
        - in: query
          name: projectSlug
          description: >-
            The slug of the project to which the link belongs. For example, for
            `app.codeqr.io/acme`, the projectSlug is `acme`.
          schema:
            type: string
            minLength: 1
            description: >-
              The slug of the project to which the link belongs. For example,
              for `app.codeqr.io/acme`, the projectSlug is `acme`.
          required: true
        - in: query
          name: domain
          schema:
            type: string
            minLength: 1
            description: >-
              The domain of the link to be retrieved. For example, for
              `codeqr.link/github`, the domain is `codeqr.link`.
          required: true
        - in: query
          name: key
          description: >-
            The key of the link to be retrieved. For example, for
            `codeqr.link/github`, the key is `github`.
          schema:
            type: string
            minLength: 1
            description: >-
              The key of the link to be retrieved. For example, for
              `codeqr.link/github`, the key is `github`.
          required: true
        - in: query
          name: linkId
          description: The unique ID of the short link.
          schema:
            type: string
            description: The unique ID of the short link.
            example: clux0rgak00011...
        - in: query
          name: externalId
          description: >-
            This is the ID of the link in your database. Must be prefixed with
            `ext_` when passed as a query parameter.
          schema:
            type: string
            description: >-
              This is the ID of the link in your database. Must be prefixed with
              `ext_` when passed as a query parameter.
            example: ext_123456
      responses:
        '200':
          description: The retrieved link
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LinkSchema'
        '400':
          $ref: '#/components/responses/400'
        '401':
          $ref: '#/components/responses/401'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        '409':
          $ref: '#/components/responses/409'
        '410':
          $ref: '#/components/responses/410'
        '422':
          $ref: '#/components/responses/422'
        '429':
          $ref: '#/components/responses/429'
        '500':
          $ref: '#/components/responses/500'
      security:
        - token: []
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Codeqr from '@codeqr/ts';

            const client = new Codeqr({
              apiKey: process.env['CODEQR_API_KEY'], // This is the default and can be omitted
            });

            const link = await client.links.retrieveInfo({
              domain: 'x',
              key: 'x',
              projectSlug: 'x',
            });

            console.log(link.id);
components:
  schemas:
    LinkSchema:
      type: object
      properties:
        id:
          type: string
          description: The unique ID of the short link.
        domain:
          type: string
          description: >-
            The domain of the short link. If not provided, the main domain of
            the project will be used (or `codeqr.link` if the project has no
            domains).
        key:
          type: string
          description: >-
            The slug of the short link. If not provided, a random 7-character
            slug will be generated.
        url:
          type: string
          format: uri
          description: The destination URL of the short link.
        archived:
          type: boolean
          default: false
          description: Whether the short link is archived.
        expiresAt:
          type: string
          nullable: true
          description: >-
            The date and time when the short link will expire in ISO-8601
            format. Must be in the future.
        expiredUrl:
          type: string
          nullable: true
          format: uri
          description: The URL to redirect to when the short link expires.
        trackConversion:
          type: boolean
          default: false
          description: '[BETA] Whether to track conversions for the short link.'
        flexible:
          type: boolean
          default: false
          description: Whether the short link is flexible.
        doIndex:
          type: boolean
          default: false
          description: Whether search engines can index the short link.
        password:
          type: string
          nullable: true
          description: The password required to access the short link destination URL.
        externalId:
          type: string
          nullable: true
          description: This is the ID of the link in your database.
        proxy:
          type: boolean
          default: false
          description: Whether the short link uses the custom link preview feature.
        title:
          type: string
          nullable: true
          description: >-
            The title of the short link generated via `api.codeqr.io/metatags`.
            Will be used for custom link preview if `proxy` is true.
        description:
          type: string
          nullable: true
          description: >-
            The description of the short link generated via
            `api.codeqr.io/metatags`. Will be used for custom link preview if
            `proxy` is true.
        image:
          type: string
          nullable: true
          description: >-
            The image of the short link generated via `api.codeqr.io/metatags`.
            Will be used for custom link preview if `proxy` is true.
        video:
          type: string
          nullable: true
          description: The video of the short link.
        rewrite:
          type: boolean
          default: false
          description: Whether the short link uses link cloaking.
        ios:
          type: string
          nullable: true
          description: The iOS destination URL for the short link for iOS device targeting.
        android:
          type: string
          nullable: true
          description: >-
            The Android destination URL for the short link for Android device
            targeting.
        geo:
          type: object
          nullable: true
          additionalProperties:
            type: string
          description: >-
            Geographic targeting information for the short link in JSON format
            `{[COUNTRY]: https://example.com }`. Learn more:
            https://codeqr.link/geo
        publicStats:
          type: boolean
          default: false
          description: Whether the short link statistics are publicly accessible.
        tagId:
          type: string
          nullable: true
          description: >-
            [DEPRECATED (use `tags` instead)]: The unique ID of the tag assigned
            to the short link.
          deprecated: true
        tags:
          type: array
          nullable: true
          items:
            $ref: '#/components/schemas/TagSchema'
          description: The tags assigned to the short link.
        folderId:
          type: string
          nullable: true
          description: The unique ID of the folder assigned to the short link.
        comments:
          type: string
          nullable: true
          description: The comments for the short link.
        notificationToken:
          type: string
          nullable: true
          description: The notification token of the short link.
        shortLink:
          type: string
          format: uri
          description: >-
            The complete URL of the short link, including the https protocol
            (for example, `https://codeqr.link/try`).
        qrCode:
          type: string
          format: uri
          description: >-
            The complete QR code URL for the short link (for example,
            `https://api.codeqr.io/qr?url=https://codeqr.link/try`).
        utm_source:
          type: string
          nullable: true
          description: The UTM source of the short link.
        utm_medium:
          type: string
          nullable: true
          description: The UTM medium of the short link.
        utm_campaign:
          type: string
          nullable: true
          description: The UTM campaign of the short link.
        utm_term:
          type: string
          nullable: true
          description: The UTM term of the short link.
        utm_content:
          type: string
          nullable: true
          description: The UTM content of the short link.
        userId:
          type: string
          description: The ID of the user who created the short link.
        projectId:
          type: string
          description: The ID of the project of the short link.
        clicks:
          type: number
          default: 0
          description: The number of clicks on the short link.
        leads:
          type: number
          default: 0
          description: The number of leads generated by the short link.
        sales:
          type: number
          default: 0
          description: The number of sales generated by the short link.
        saleAmount:
          type: number
          default: 0
          description: The amount of the sale generated by the link.
        lastClicked:
          type: string
          nullable: true
          description: The date and time when the short link was last clicked.
        createdAt:
          type: string
          description: The date and time when the short link was created.
        updatedAt:
          type: string
          description: The date and time when the short link was last updated.
        preRedirection:
          type: boolean
          default: false
          description: Whether the short link has pre-redirection.
        pageId:
          type: string
          nullable: true
          description: The ID of the page to redirect to before the link destination.
        pageUrl:
          type: string
          nullable: true
          description: The URL of the page to redirect to before the link destination.
        isFormMandatory:
          type: boolean
          default: false
          description: If the form is mandatory for the page.
        filled:
          type: boolean
          default: false
          description: Whether the link is filled or not.
      required:
        - id
        - domain
        - key
        - url
        - archived
        - expiresAt
        - expiredUrl
        - trackConversion
        - flexible
        - doIndex
        - password
        - externalId
        - proxy
        - title
        - description
        - image
        - video
        - rewrite
        - ios
        - android
        - geo
        - publicStats
        - tagId
        - tags
        - folderId
        - comments
        - notificationToken
        - utm_source
        - utm_medium
        - utm_campaign
        - utm_term
        - utm_content
        - userId
        - projectId
        - clicks
        - leads
        - sales
        - saleAmount
        - lastClicked
        - createdAt
        - updatedAt
        - preRedirection
        - isFormMandatory
        - filled
      title: Link
    TagSchema:
      type: object
      properties:
        id:
          type: string
          description: The unique ID of the tag.
        name:
          type: string
          description: The name of the tag.
        color:
          type: string
          enum:
            - red
            - yellow
            - green
            - blue
            - purple
            - pink
            - brown
          description: The color of the tag.
      required:
        - id
        - name
        - color
      title: Tag
  responses:
    '400':
      description: >-
        The server cannot or will not process the request due to something that
        is perceived to be a client error (e.g., malformed request syntax,
        invalid request message framing, or deceptive request routing).
      content:
        application/json:
          schema:
            x-speakeasy-name-override: BadRequest
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - bad_request
                    description: A short code indicating the error code returned.
                    example: bad_request
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#bad-request
                required:
                  - code
                  - message
            required:
              - error
    '401':
      description: >-
        Although the HTTP standard specifies "unauthorized", semantically this
        response means "unauthenticated". That is, the client must authenticate
        itself to get the requested response.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Unauthorized
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unauthorized
                    description: A short code indicating the error code returned.
                    example: unauthorized
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#unauthorized
                required:
                  - code
                  - message
            required:
              - error
    '403':
      description: >-
        The client does not have access rights to the content; that is, it is
        unauthorized, so the server is refusing to give the requested resource.
        Unlike 401 Unauthorized, the client's identity is known to the server.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Forbidden
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - forbidden
                    description: A short code indicating the error code returned.
                    example: forbidden
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#forbidden
                required:
                  - code
                  - message
            required:
              - error
    '404':
      description: The server cannot find the requested resource.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: NotFound
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - not_found
                    description: A short code indicating the error code returned.
                    example: not_found
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#not-found
                required:
                  - code
                  - message
            required:
              - error
    '409':
      description: >-
        This response is sent when a request conflicts with the current state of
        the server.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: Conflict
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - conflict
                    description: A short code indicating the error code returned.
                    example: conflict
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#conflict
                required:
                  - code
                  - message
            required:
              - error
    '410':
      description: >-
        This response is sent when the requested content has been permanently
        deleted from server, with no forwarding address.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: InviteExpired
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - invite_expired
                    description: A short code indicating the error code returned.
                    example: invite_expired
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: https://docs.codeqr.io/api-reference/errors#invite-expired
                required:
                  - code
                  - message
            required:
              - error
    '422':
      description: >-
        The request was well-formed but was unable to be followed due to
        semantic errors.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: UnprocessableEntity
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - unprocessable_entity
                    description: A short code indicating the error code returned.
                    example: unprocessable_entity
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#unprocessable-entity
                required:
                  - code
                  - message
            required:
              - error
    '429':
      description: >-
        The user has sent too many requests in a given amount of time ("rate
        limiting")
      content:
        application/json:
          schema:
            x-speakeasy-name-override: RateLimitExceeded
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - rate_limit_exceeded
                    description: A short code indicating the error code returned.
                    example: rate_limit_exceeded
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#rate-limit_exceeded
                required:
                  - code
                  - message
            required:
              - error
    '500':
      description: The server has encountered a situation it does not know how to handle.
      content:
        application/json:
          schema:
            x-speakeasy-name-override: InternalServerError
            type: object
            properties:
              error:
                type: object
                properties:
                  code:
                    type: string
                    enum:
                      - internal_server_error
                    description: A short code indicating the error code returned.
                    example: internal_server_error
                  message:
                    x-speakeasy-error-message: true
                    type: string
                    description: A human readable explanation of what went wrong.
                    example: The requested resource was not found.
                  doc_url:
                    type: string
                    description: >-
                      A link to our documentation with more details about this
                      error code
                    example: >-
                      https://docs.codeqr.io/api-reference/errors#internal-server_error
                required:
                  - code
                  - message
            required:
              - error
  securitySchemes:
    token:
      type: http
      description: Default authentication mechanism
      scheme: bearer

````